package com.crijaen.witpeak;

import java.io.Serializable;

//Global class implemented with Singleton to permit only 1 instance of global
public class Global implements Serializable {

    private static volatile Global sSoleInstance;
    static int minElevation;
    static boolean needNewPoints = true;
    static int radiusCF = 1;  //Close=1, Far=2
    static int radiusRadarClose = 10001;
    static int radiusRadarFar = 20001;
    static float AccelSensibility = (float) 0.5;
    static int IcoTam= 150;
    static int IcoMarg= 10;
    static int IcoSpace= 50;
    static int ifMetersMoved = 5;
    static double latInfo;
    static double lonInfo;
    static double eleInfo;
    static double RadiusInfo=1000;// When you consult a PDI INFO(lat,long) also will see objects in RadiusInfo



    //private constructor.
    private Global(){

        //Prevent form the reflection api.
        if (sSoleInstance != null){
            throw new RuntimeException("Use getInstance() method to get the single instance of this class.");
        }
    }

    private static Global getInstance() {
        if (sSoleInstance == null) { //if there is no instance available... create new one
            synchronized (Global.class) {
                if (sSoleInstance == null) {
                    sSoleInstance = new Global();
                }
            }
        }
        return sSoleInstance;
    }

    //Make singleton from serialize and deserialize operation.
    protected Global readResolve() {
        return getInstance();
    }
}


/*
public class Global {
    public static int minElevation;
    public static boolean needNewPoints = true;
    public static int radiusCF = 1;  //Close=1, Far=2
    public static int radiusRadar = 10001;
    public static int radiusRadarClose = 1001;
    public static int radiusRadarFar = 10001;
}
*/