package com.crijaen.witpeak;

import android.Manifest;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.os.Build;
import android.os.Bundle;

import android.app.Activity;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.widget.FrameLayout;
import android.widget.Toast;

import java.util.Collections;
import java.util.Locale;
import java.util.concurrent.TimeUnit;

import static com.crijaen.witpeak.Global.AccelSensibility;



public class MainActivity extends Activity {
    private OverlayView arContent;
    private Context context;


    /** Called when the activity is first created. */
    @RequiresApi(api = Build.VERSION_CODES.M)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.main);
        FrameLayout arViewPane = (FrameLayout) findViewById(R.id.ar_view_panel);

        //******************************************************
        //GetPlacesTask getPlacesTask = null;
        //getPlacesTask.execute(new String[]{"https://maps.googleapis.com/maps/api/place/nearbysearch/json?location=28.99666,-13.59638&radius=3000&type=natural_feature&key=AIzaSyBZ3qxM5OKGUe6e77IMnjM38PI90_LNzac"});
        //******************************************************
        /*
        if ( (checkSelfPermission(android.Manifest.permission.ACCESS_FINE_LOCATION)!= 0))        {            ActivityCompat.requestPermissions(this, new String[]{ACCESS_FINE_LOCATION},1);        }
        if ( (checkSelfPermission(android.Manifest.permission.INTERNET)!= 0))        {            ActivityCompat.requestPermissions(this, new String[]{INTERNET},1);        }
        if ( (checkSelfPermission(android.Manifest.permission.ACCESS_NETWORK_STATE)!= 0))        {            ActivityCompat.requestPermissions(this, new String[]{ACCESS_NETWORK_STATE},1);        }
        if ( (checkSelfPermission(android.Manifest.permission.WRITE_EXTERNAL_STORAGE)!=0)) {        ActivityCompat.requestPermissions(this, new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);}
*/

       /*if ((checkSelfPermission(Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED)) {
            ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.CAMERA}, 1);
        }
       if ((checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED)) {
            ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 1);
       }*/



        ArDisplayView arDisplay = new ArDisplayView(getApplicationContext(), this);
        arViewPane.addView(arDisplay);
        arContent = new OverlayView(getApplicationContext());

        //recovery preferences****************
        SharedPreferences preferencias = getSharedPreferences("WitPeakPReferences",MODE_PRIVATE);


        //**************************************
        //*********************  minElevation **
        //**************************************
        int valorInt1=0;
        valorInt1= (int) preferencias.getInt("minElevation",-1);
        if (valorInt1==-1){//if not exists shared option, set it to 1000m
            ////////arContent.setminElevation(100);
            Global.minElevation = 100;
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putInt("minElevation", 100);
            editor.commit();
            Global.minElevation = valorInt1;
        }
        else
        {//set it to shared value
            Global.minElevation=valorInt1;
            ///////arContent.setminElevation(valorInt1);
        }
        //**************************************
        //********************** RadiusCF     **  Used to know whitch radius is been used, close or far
        //**************************************
        int valorRCF= (int) preferencias.getInt("radiusCF",-1);
        if (valorRCF == -1){//if not exists shared option, set it to 1 (radius close)
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putInt("radiusCF", 1);
            editor.commit();
            Global.radiusCF=1;
        }
        else
        {//set it to Global. If preferences/radiusCF=1 then global.radiuscf=1   if preferences/radiusCF=2 then global.radiuscf=2
           Global.radiusCF= valorRCF;        }
        //**************************************
        //********************** Radius Close **
        //**************************************
        valorInt1= (int) preferencias.getInt("radiusRadarClose",-1);
        if (valorInt1==-1){//if not exists shared option, set it to 1000m
            //arContent.setRadiusRadar(1000);
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putInt("radiusRadarClose", 10000);
            editor.commit();
            Global.radiusRadarClose=10000;
        }
        else
        {//set it to shared value
             Global.radiusRadarClose=valorInt1;       }  //Global.arContent.setRadiusRadar(valorInt1);
        //**************************************
        //***********************  Radius Far **
        //**************************************
        int valorInt2= (int) preferencias.getInt("radiusRadarFar",-1);
        if (valorInt2==-1){//if not exists shared option, set it to 10000m
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putInt("radiusRadarFar", 20000);
            editor.commit();
            Global.radiusRadarFar=20000;
        }
        else
        {//set it to shared value
            Global.radiusRadarFar=valorInt2;}
        //***************************************

        //**************************************
        //*********  Accelerometer sensibility**
        //**************************************
        int valorAccel= (int) preferencias.getFloat("AccelSensibility",-1);
        if (valorAccel==-1){//if not exists shared option, set it to 0.5
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putFloat("AccelSensibility", (float) 0.5);
            editor.commit();
            AccelSensibility = (float) 0.5;
        }
        else
        {//set it to shared value
            AccelSensibility=valorAccel;}
        //***************************************





        //**************************************
        //******************  language/region ** set  if exists in parameters, otherwise do nothing...
        //**************************************
        String language="",country="";
        language = preferencias.getString("language", "");
        country = preferencias.getString("country", "");
        if ((language == "")&&(country == ""))
        {//if laguage or country not congugured--> set it in preferences
            if (getLanguage().contains("es")) {language = "es";};
            if (getLanguage().contains("us")) {language = "us";};
            if (getCountry().contains("ES")) {country = "ES";};
            if (getCountry().contains("US")) {country = "US";};

            setAppLocale(language,country);
            SharedPreferences.Editor editor = preferencias.edit();
            editor.putString("language", language);
            editor.putString("country", country);
            editor.commit();
        }else
        {//if exists in preferences--> activate it in applicacion
            setAppLocale(language,country);
        }


        arViewPane.addView(arContent);
    }


    //***************************
    //************** Change Locale
    //private void setAppLocale(String localeCode)
    public void setAppLocale(String lan, String reg)
    {
        Locale localizacion = new Locale(lan, reg);
        Locale.setDefault(localizacion);
        Configuration config = new Configuration();
        config.locale = localizacion;
        getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());
    }
    //*************************** Change Locale
    private String getLanguage()
    {
       return String.valueOf(Collections.singletonList(Locale.getDefault().getLanguage()));
    }
    private String getCountry()
    {
        return String.valueOf(Collections.singletonList(Locale.getDefault().getCountry()));
    }

    @Override
    protected void onPause() {
        arContent.onPause();
        super.onPause();
    }

    @Override
    protected void onResume() {
        super.onResume();
        arContent.onResume();
    }



}
//Version near finnale