package com.crijaen.witpeak.Objects;

import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.List;

import com.crijaen.witpeak.R;

public class Adapter extends RecyclerView.Adapter<Adapter.MarksviewHolder>{
    List<Mark> marks;

    public Adapter(List<Mark> marks){
        this.marks = marks;
    }

    @NonNull
    @Override
    public MarksviewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.row_recycler,parent,false);
        MarksviewHolder holder=new MarksviewHolder(v);
        return holder;

    }

    @Override
    public void onBindViewHolder(@NonNull MarksviewHolder holder, int position) {
        Mark mark=marks.get(position);
        holder.textViewfila1.setText("Nombre: "+mark.getName());
        holder.textViewFila2.setText("Lat: "+String.valueOf(mark.getLongitude())+"   Lon: "+String.valueOf(mark.getLatitude())+ "   Ele: "+String.valueOf(mark.getElevation())+"m");
        holder.textViewFila3.setText("Info"+mark.getInfo());
        holder.textViewFila4.setText("");
    }

    @Override
    public int getItemCount() {
        return marks.size();
    }

    public static class MarksviewHolder extends RecyclerView.ViewHolder{

        TextView textViewfila1,textViewFila2,textViewFila3,textViewFila4;

        public MarksviewHolder(@NonNull View itemView) {
            super(itemView);
            textViewfila1=(TextView)itemView.findViewById(R.id.textview_fila1);
            textViewFila2=(TextView)itemView.findViewById(R.id.textview_fila2);
            textViewFila3=(TextView)itemView.findViewById(R.id.textview_fila3);
            textViewFila4=(TextView)itemView.findViewById(R.id.textview_fila4);
        }
    }
}
