package com.crijaen.witpeak;

import android.Manifest;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ColorFilter;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.Paint;
import android.graphics.Paint.Align;
import android.graphics.drawable.Drawable;
import android.hardware.Camera;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.text.TextPaint;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.ScaleGestureDetector;
import android.view.View;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.File;
import java.io.FileOutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.Date;
import java.util.concurrent.TimeUnit;


public class OverlayView extends View implements SensorEventListener,LocationListener{
	private Context context;
	private Handler handler;

	private int RedPdiPos=0;
	private Location previousLocate=null;
	/////private boolean needNewPoints = true;
	private int textSize = 50;
	private boolean waitingForPOI = true;
	///////public  int minElevation= 100; //cerro<200m , monte<700 , mountain>700
    //private int radiusRadar= 10001;
    private int delayView=0;//miliseconds
	private int ClickSensitive= 20;
	private int iColor = Color.parseColor("#FFFFFF");
	private int Azimuth = 0;//degrees

	//********** Ontouch
	private static final int INVALID_POINTER_ID = -1;
	private Drawable mImageAgregar,mImageFlechaIzq,mImageFlechaDer,mImageInfo,mImageExit,mImageConfig,mImageRadar,mImageCompass;
	private int mEx,mEy,mGx,mGy,mRx,mRy,mINx,mINy,mIx,mIy,mDx,mDy;
	private float mPosX;
	private float mPosY;
	private float mLastTouchX;
	private float mLastTouchY;
	private int mActivePointerId = INVALID_POINTER_ID;
	private ScaleGestureDetector mScaleDetector;
	private float mScaleFactor = 0.1f;

	//for public setting
//	public int getRadiusRadar() {		return this.radiusRadar;	}
//	public void setRadiusRadar(int value){this.radiusRadar=value;}
	///////public int getminElevation() {		return this.minElevation;	}
	///////public void setminElevation(int value){this.minElevation=value;}
	///////public void enableneedNewPoints(){this.needNewPoints=true;}


	public OverlayView(Context context, AttributeSet attrs) {
		this(context, attrs, 0);
	}

	public OverlayView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		mScaleDetector = new ScaleGestureDetector(context, new ScaleListener());
	}

	public OverlayView(Context context) {
		//super(context);

		this(context, null, 0);
		mImageInfo = getResources().getDrawable(R.drawable.info);
		mImageInfo.setBounds(0, 0, mImageInfo.getIntrinsicWidth(), mImageInfo.getIntrinsicHeight());

		mImageFlechaDer = getResources().getDrawable(R.drawable.flechader);
		mImageFlechaDer.setBounds(0, 0, mImageFlechaDer.getIntrinsicWidth(), mImageFlechaDer.getIntrinsicHeight());

		mImageFlechaIzq = getResources().getDrawable(R.drawable.flechaizq);
		mImageFlechaIzq.setBounds(0, 0, mImageFlechaIzq.getIntrinsicWidth(), mImageFlechaIzq.getIntrinsicHeight());

		mImageConfig = getResources().getDrawable(R.drawable.tuercadeopciones);
		mImageConfig.setBounds(0, 0, mImageConfig.getIntrinsicWidth(), mImageConfig.getIntrinsicHeight());

		mImageRadar = getResources().getDrawable(R.drawable.radar);
		mImageRadar.setBounds(0, 0, mImageRadar.getIntrinsicWidth(), mImageRadar.getIntrinsicHeight());

		mImageExit = getResources().getDrawable(R.drawable.salir);
		mImageExit.setBounds(0, 0, mImageExit.getIntrinsicWidth(), mImageExit.getIntrinsicHeight());

		mImageCompass = getResources().getDrawable(R.drawable.brujula2);
		//.setBounds(0, 0, mImageCompass.getIntrinsicWidth(), mImageCompass.getIntrinsicHeight());


		//this.context = context;
		//this.handler = new Handler();

		locationManager = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);
		sensors = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);
		accelSensor = sensors.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		compassSensor = sensors.getDefaultSensor(Sensor.TYPE_MAGNETIC_FIELD);
		gyroSensor = sensors.getDefaultSensor(Sensor.TYPE_GYROSCOPE);

		startSensors();
		startGPS();

		/*String requiredPermission = "android.permission.Camera";
		int checkVal = getContext().checkCallingOrSelfPermission(requiredPermission);
		if (checkVal== PackageManager.PERMISSION_GRANTED)
		{
            // get some camera parameters
            Camera camera = Camera.open();
            Camera.Parameters params = camera.getParameters();
            verticalFOV = params.getVerticalViewAngle();
            horizontalFOV = params.getHorizontalViewAngle();
            camera.release();
        }*/

		// get some camera parameters
		Camera camera = Camera.open();
		Camera.Parameters params = camera.getParameters();
		verticalFOV = params.getVerticalViewAngle();
		horizontalFOV = params.getHorizontalViewAngle();
		camera.release();


		// paint for text
		contentPaint = new TextPaint(Paint.ANTI_ALIAS_FLAG);
		contentPaint.setTextAlign(Align.LEFT);
		contentPaint.setTextSize(50);
		contentPaint.setColor(Color.RED);

		// paint for target
		targetPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		targetPaint.setColor(Color.GREEN);



	}




	private class ScaleListener extends ScaleGestureDetector.SimpleOnScaleGestureListener {
		@Override
		public boolean onScale(ScaleGestureDetector detector) {
			mScaleFactor *= detector.getScaleFactor();

			// Don't let the object get too small or too large.
			mScaleFactor = Math.max(0.1f, Math.min(mScaleFactor, 10.0f));

			invalidate();
			return true;
		}
	}

/*
	private void takeScreenshot() {
		Date now = new Date();
		android.text.format.DateFormat.format("yyyy-MM-dd_hh:mm:ss", now);

		try {
			// image naming and path  to include sd card  appending name you choose for file
			String mPath = Environment.getExternalStorageDirectory().toString() + "/" + now + ".jpg";

			// create bitmap screen capture

            View v1 = getRootView();
			v1.setDrawingCacheEnabled(true);
			Bitmap bitmap = Bitmap.createBitmap(v1.getDrawingCache());
			v1.setDrawingCacheEnabled(false);


			File imageFile = new File(mPath);

			FileOutputStream outputStream = new FileOutputStream(imageFile);
			int quality = 100;
			bitmap.compress(Bitmap.CompressFormat.JPEG, quality, outputStream);
			outputStream.flush();
			outputStream.close();

			//openScreenshot(imageFile);
		} catch (Throwable e) {
			// Several error may come out with file handling or DOM
			e.printStackTrace();
		}
	}

	public static Bitmap screenShot(View view) {
		Bitmap bitmap = null;
		if (view.getWidth() > 0 && view.getHeight() > 0) {
			bitmap = Bitmap.createBitmap(view.getWidth(),
					view.getHeight(), Bitmap.Config.ARGB_8888);
			Canvas canvas = new Canvas(bitmap);
			view.draw(canvas);
		}
		return bitmap;
	}
*/

	//Sounds on click
	MediaPlayer clickPhoto = MediaPlayer.create(super.getContext(), R.raw.photo);
	MediaPlayer clickError = MediaPlayer.create(super.getContext(), R.raw.error);
	MediaPlayer clickTap = MediaPlayer.create(super.getContext(), R.raw.tap);
	MediaPlayer clickBye = MediaPlayer.create(super.getContext(), R.raw.bye);

	@Override
	public boolean onTouchEvent(MotionEvent ev){
		mScaleDetector.onTouchEvent(ev);
		final int action = ev.getAction();
		//int Dist=0;		int mDist=10000000;		int clickPoint=-1;		int X1=0,Y1=0;		int i=0;

		switch (action & MotionEvent.ACTION_MASK) {
			case MotionEvent.ACTION_DOWN: {
				final float x = ev.getX();
				final float y = ev.getY();


				//Flecha Izq click
				if (  ((x>=mIx)&&(x<=mIx+Global.IcoTam))    &&  ((y>=mIy)&&(y<=mIy+Global.IcoTam))) {
					if (placesArrayList.size()>0)
					{
						clickTap.start();
						//************************************************************
						//***** looking for next visible point (LEFT) on Array of places. Not Real left point, only index of vector. It can be improve on future...
						boolean busca = true;
						RedPdiPos = RedPdiPos + 1;
						if (RedPdiPos > placesArrayList.size() - 1) {
							RedPdiPos = 0;
						}
						while (busca) {
							if (((Global.radiusCF == 1) && (placesArrayList.get(RedPdiPos).getDistance() < Global.radiusRadarClose)) || ((Global.radiusCF == 2) && (placesArrayList.get(RedPdiPos).getDistance() < Global.radiusRadarFar))) //If point distance  is less than radius
							{
								if (placesArrayList.get(RedPdiPos).getElevation() > Global.minElevation) //print PDI only if elevation>elevation in parameters
								{//if point is visible, then exit
									busca = false;
								} else {
									//if not, continue to find a visible point
									RedPdiPos = RedPdiPos + 1;
									if (RedPdiPos > placesArrayList.size() - 1) {
										RedPdiPos = 0;
									}
								}
							} else {
								//if not, continue to find a visible point
								RedPdiPos = RedPdiPos + 1;
								if (RedPdiPos > placesArrayList.size() - 1) {
									RedPdiPos = 0;
								}
							}
						}
					}
					else{
						clickError.start();
					}
				}

				//FlechaDer click
				if (  ((x>=mDx)&&(x<=mDx+Global.IcoTam))    &&  ((y>=mDy)&&(y<=mDy+Global.IcoTam))) {
					if (placesArrayList.size()>0)
					{
						clickTap.start();
						//************************************************************
						//***** looking for next visible point (RIGHT) on Array of places. Not Real left point, only index of vector. It can be improve on future...
						boolean busca = true;
						RedPdiPos = RedPdiPos - 1;
						if (RedPdiPos < 0) {
							RedPdiPos = placesArrayList.size() - 1;
						}
						while (busca) {
							if (((Global.radiusCF == 1) && (placesArrayList.get(RedPdiPos).getDistance() < Global.radiusRadarClose)) || ((Global.radiusCF == 2) && (placesArrayList.get(RedPdiPos).getDistance() < Global.radiusRadarFar))) //If point distance  is less than radius
							{
								if (placesArrayList.get(RedPdiPos).getElevation() > Global.minElevation) //print PDI only if elevation>elevation in parameters
								{//if point is visible, then exit
									busca = false;
								} else {
									//if not, continue to find a visible point
									RedPdiPos = RedPdiPos - 1;
									if (RedPdiPos < 0) {
										RedPdiPos = placesArrayList.size() - 1;
									}
								}
							} else {
								//if not, continue to find a visible point
								RedPdiPos = RedPdiPos - 1;
								if (RedPdiPos < 0) {
									RedPdiPos = placesArrayList.size() - 1;
								}
							}
						}

					}
					else{
						clickError.start();
					}
				}


				//look up for PDI Info(also can edit) if exists, if not, User can Edit
				//Info click
				if (  ((x>=mINx)&&(x<=mINx+Global.IcoTam))    &&  ((y>=mINy)&&(y<=mINy+Global.IcoTam))) {
					clickTap.start();
					if (placesArrayList.size()>0)
					{
						Global.latInfo = placesArrayList.get(RedPdiPos).getLatitud();
						Global.lonInfo = placesArrayList.get(RedPdiPos).getLongitud();
						Global.eleInfo = placesArrayList.get(RedPdiPos).getElevation();
						Intent intent = new Intent(getContext() ,PdiInfo.class);
						getContext().startActivity(intent);
					}
					else
					{
						Toast.makeText(getContext(),getResources().getString(R.string.WaitingPDI),Toast.LENGTH_SHORT).show();
						try {
							TimeUnit.MICROSECONDS.sleep(250);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
				}







				//Radar click
				if (  ((x>=mRx)&&(x<=mRx+Global.IcoTam))    &&  ((y>=mRy)&&(y<=mRy+Global.IcoTam))) {
					if (Global.radiusCF==1)
					{
						Global.radiusCF=2;
					}
					else
					{
						Global.radiusCF=1;
					}
					clickTap.start();
				}
				//Exit click
				if (  ((x>=mEx)&&(x<=mEx+Global.IcoTam))    &&  ((y>=mEy)&&(y<=mEy+Global.IcoTam))) {
					clickBye.start();
					System.exit(0);

				}

				//configuration
				if (  ((x>=mGx)&&(x<=mGx+Global.IcoTam))    &&  ((y>=mGy)&&(y<=mGy+Global.IcoTam))) {
					clickTap.start();
					//open preferences activity
					Intent intent = new Intent(getContext() ,PreferencesActivity.class);
					getContext().startActivity(intent);
				}



				/*
				//probe....doesn't work...for now
				for (i=0;i<placesArrayList.size();i++){
					X1=placesArrayList.get(i).getPosX();
					Y1=placesArrayList.get(i).getPosY();
					Dist= (int) Math.sqrt(Math.pow(X1-x,2)+Math.pow(Y1-y,2));
					if (Dist < mDist)		{
						mDist = Dist;
						clickPoint=i;
					}
				}
				if (mDist<=ClickSensitive){
					//clicked near point
					placesArrayList.get(i);
					Log.d("DEBUG_CLICK",placesArrayList.get(i).toString());
				}
				else {
					//no points exists
				}*/




				mLastTouchX = x;
				mLastTouchY = y;
				mActivePointerId = ev.getPointerId(0);
				break;
			}
		}
		return true;
	}

	//********** Ontouch  END




	//********** GetPlacesTask******************************************
	ArrayList<Place> placesArrayList = new ArrayList<>();
	private class GetPlacesTask extends AsyncTask<String, String, ArrayList<Place>>
    {
        @Override
        protected void onPreExecute()
        {
            super.onPreExecute();
        }

        @Override
        protected ArrayList<Place> doInBackground(String... stringURL)
        {
            Place place = null;
            Location Tmp=new Location("");
            try
            {
                URL url = new URL(stringURL[0]);
                HttpHandler httpHandler = new HttpHandler(url);
                String result = httpHandler.getURLResponse();
                JSONObject mainResponse = new JSONObject(result);
                JSONArray resultsKeyArray = mainResponse.getJSONArray("results");

				placesArrayList.clear();//If new data... remove previus data first
                for (int i = 0; i<resultsKeyArray.length(); i++)
                {
                    JSONObject placeJson = resultsKeyArray.getJSONObject(i);
                    if(placeJson.has("geometry"))
                    {
                        double latitud = placeJson.getJSONObject("geometry").getJSONObject("location").getDouble("lat");
                        double longitud = placeJson.getJSONObject("geometry").getJSONObject("location").getDouble("lng");
                        String nombre = placeJson.getString("name");

                        URL urlelevation = new URL("https://maps.googleapis.com/maps/api/elevation/json?locations="+String.valueOf(latitud)+","+String.valueOf(longitud)+"&key=AIzaSyBZ3qxM5OKGUe6e77IMnjM38PI90_LNzac");
                        HttpHandler httpHandler2 = new HttpHandler(urlelevation);
                        String resultElevation = httpHandler2.getURLResponse();
                        JSONObject mainResponse2 = new JSONObject(resultElevation);
                        double elevation = mainResponse2.getJSONArray("results").getJSONObject(0).getDouble("elevation");
						Tmp.setLatitude(latitud);///////////////////////////////////////////////////////////////
						Tmp.setLongitude(longitud);/////////////////////////////////////////////////////////////Calculate distance from last location
						Tmp.setAltitude(elevation);/////////////////////////////////////////////////////////////
                        place = new Place(nombre,latitud,longitud,elevation,lastLocation.distanceTo(Tmp));
                        placesArrayList.add(place);
                    }
                }
                Log.d("PLACESARRAY", placesArrayList.toString());

            }
            catch(Exception e)
            {
                e.printStackTrace();
            }

            return placesArrayList;
        }

        @Override
        protected void onPostExecute(ArrayList<Place> placesArrayList)
        {
            super.onPostExecute(placesArrayList);

            waitingForPOI = false;
            for(Place place : placesArrayList)
            {
                //Photo placePhoto = place.getPlacePhoto();
                //imageUrls.add("NULL_URL");
            }
//            adapter.notifyDataSetChanged();
        }
    }//End of GetPlacesTask


//**********End of GetPlacesTask******************************************











	private final static Location pdiLocation = new Location("manual");
    static {
        pdiLocation.setLatitude(0);
		pdiLocation.setLongitude(0);
		pdiLocation.setAltitude(0);
    }


	String accelData = "Accelerometer Data";
	String compassData = "Compass Data";
	String gyroData = "Gyro Data";

	private LocationManager locationManager = null;
	private SensorManager sensors = null;

	private Location lastLocation;
	private float[] lastAccelerometer;
	private float[] lastCompass;

	private float verticalFOV;
	private float horizontalFOV;

	private boolean isAccelAvailable;
	private boolean isCompassAvailable;
	private boolean isGyroAvailable;
	private Sensor accelSensor;
	private Sensor compassSensor;
	private Sensor gyroSensor;

	private TextPaint contentPaint;
	private TextPaint PDItext;

	private Paint targetPaint;






	private void startSensors() {
		isAccelAvailable = sensors.registerListener(this, accelSensor,SensorManager.SENSOR_DELAY_NORMAL);
		isCompassAvailable = sensors.registerListener(this, compassSensor,SensorManager.SENSOR_DELAY_NORMAL);
		isGyroAvailable = sensors.registerListener(this, gyroSensor,	SensorManager.SENSOR_DELAY_NORMAL);
	}

	private void startGPS() {
		Criteria criteria = new Criteria();
		criteria.setAccuracy(Criteria.NO_REQUIREMENT);
		// criteria.setAccuracy(Criteria.ACCURACY_FINE);
		// Para poder hacer las pruebas en interior. Cuando estemmos en exterior hay que elegir ACURRACY_FINE
		// Esto hay que pedirlo en las opciones

		criteria.setPowerRequirement(Criteria.NO_REQUIREMENT);
		String best = locationManager.getBestProvider(criteria, true);
		locationManager.requestLocationUpdates(best, 50, 0, this);

/*		//String requiredPermission = "Manifest.permission.ACCESS_FINE_LOCATION";
		//int checkVal = getContext().checkCallingOrSelfPermission(requiredPermission);
		if (getContext().checkCallingOrSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION)== PackageManager.PERMISSION_GRANTED) {

		}*/
	}

	//change color of a bitmap
	public Bitmap replaceColor(Bitmap src, int fromColor, int targetColor) {
		if(src == null) {
			return null;
		}
		// Source image size
		int width = src.getWidth();
		int height = src.getHeight();
		int[] pixels = new int[width * height];
		//get pixels
		src.getPixels(pixels, 0, width, 0, 0, width, height);

		for(int x = 0; x < pixels.length; ++x) {
			pixels[x] = (pixels[x] == fromColor) ? targetColor : pixels[x];
		}
		// create result bitmap output
		Bitmap result = Bitmap.createBitmap(width, height, src.getConfig());
		//set pixels
		result.setPixels(pixels, 0, width, 0, 0, width, height);

		return result;
	}


	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);


		//*****140519
		//Change PNG color, on solid image
		int red   = (iColor & 0xFF0000) / 0xFFFF;
		int green = (iColor & 0xFF00) / 0xFF;
		int blue  = iColor & 0xFF;
		float[] matrix = { 0, 0, 0, 0, red,
				0, 0, 0, 0, green,
				0, 0, 0, 0, blue,
				0, 0, 0, 1, 0 };
		ColorFilter colorFilter = new ColorMatrixColorFilter(matrix);

		mImageFlechaIzq.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageFlechaIzq.setColorFilter(colorFilter);
		mImageFlechaDer.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageFlechaDer.setColorFilter(colorFilter);

		mImageInfo.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageInfo.setColorFilter(colorFilter);
		mImageExit.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageExit.setColorFilter(colorFilter);

		if (Global.radiusCF == 1)
		{
			mImageRadar = getResources().getDrawable(R.drawable.radarnewc);
		}
		else
		{
			mImageRadar = getResources().getDrawable(R.drawable.radarnewf);
		}
		mImageRadar.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageRadar.setColorFilter(colorFilter);
		mImageConfig.setBounds(0,0,Global.IcoTam,Global.IcoTam);
		mImageConfig.setColorFilter(colorFilter);
		mImageCompass.setBounds(0,0,2*Global.IcoTam,2*Global.IcoTam);


		//paint icons



		canvas.save();
		mPosX=mINx=10;
		mPosY=mINy=getHeight()-Global.IcoTam-Global.IcoMarg;//canvasheight-iconsize-margin
		canvas.translate(mPosX, mPosY);		//canvas.scale(0.1f, 0.1f);
		mImageInfo.draw(canvas);


		mIx=10;
		mIy=getHeight()-4*(Global.IcoMarg+Global.IcoTam);
		canvas.translate(0, -3*(Global.IcoMarg+Global.IcoTam));		//canvas.scale(0.1f, 0.1f);
		mImageFlechaIzq.draw(canvas);

		mDx=getWidth()-Global.IcoMarg-Global.IcoTam;
		mDy=mIy;
		canvas.translate(+mDx,0 );		//canvas.scale(0.1f, 0.1f);
		mImageFlechaDer.draw(canvas);


		canvas.restore();
		canvas.save();
		mPosX=mRx=canvas.getWidth()-2*Global.IcoTam-Global.IcoSpace-Global.IcoMarg;
		mPosY=mRy=canvas.getHeight()-Global.IcoTam-Global.IcoMarg;//canvasheight-iconsize-margin
		canvas.translate(mPosX, mPosY);
		mImageRadar.draw(canvas);
		mEx=mRx+Global.IcoTam+Global.IcoSpace;mEy=mRy;
		canvas.translate(Global.IcoTam+Global.IcoSpace, 0);
		mImageExit.draw(canvas);
		mGx=mEx;mGy=mEy-Global.IcoSpace-Global.IcoTam;
		canvas.translate(0, -Global.IcoSpace-Global.IcoTam);
		mImageConfig.draw(canvas);
		canvas.restore();



		//getion click visual test
		/*canvas.save();
		Paint paint2=new Paint(Paint.ANTI_ALIAS_FLAG);
		canvas.drawRect(mCx,mINy,mCx+IcoTam,mINy+IcoTam, paint2);
		canvas.drawRect(mRx,mRy,mRx+IcoTam,mRy+IcoTam, paint2);
		canvas.drawRect(mEx,mEy,mEx+IcoTam,mEy+IcoTam, paint2);
		canvas.drawRect(mGx,mGy,mGx+IcoTam,mGy+IcoTam, paint2);
		canvas.restore();
		//*****130419
		*/



		// CurBearing init
		float curBearingToMW = 0.0f;

		StringBuilder text = new StringBuilder();
		StringBuilder	advise = new StringBuilder();
		advise.append("buscando....");
		//text.append(accelData).append("\n");		//text.append(compassData).append("\n");		//text.append(gyroData).append("\n");

		Azimuth = (int) (lastCompass[0] * 57.2957795f);
		if (lastLocation != null) {
			if (previousLocate == null)
			{//need to find new points ... first time
				Global.needNewPoints=true;
				previousLocate = lastLocation;
			}
			else
			{
				if (lastLocation.distanceTo(previousLocate) > Global.ifMetersMoved)
				{//need to find for new interest point if has moved X meters
					Global.needNewPoints=true;
				}
				else {
					Global.needNewPoints=false;
				}
                previousLocate = lastLocation;
			}


			if (Global.needNewPoints)
			{
				//text.append(String.format("GPS = (%.3f, %.3f) @ (%.2f meters up)", lastLocation.getLatitude(), lastLocation.getLongitude(), lastLocation.getAltitude())).append("\n");
				//******************************************************
				///******************************************************

				try {
					GetPlacesTask getPlacesTask2 = new GetPlacesTask();//find all points distance = far, and  then filter on draw
					getPlacesTask2.execute(new String[]{"https://maps.googleapis.com/maps/api/place/nearbysearch/json?location=" + lastLocation.getLatitude() + "," + lastLocation.getLongitude() + "&radius="+Global.radiusRadarFar+"&type=natural_feature&key=AIzaSyBZ3qxM5OKGUe6e77IMnjM38PI90_LNzac"});
					getPlacesTask2.get();
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}

			}

			if (placesArrayList.size()>0)
			{
				// compute rotation matrix
				float rotation[] = new float[9];
				float identity[] = new float[9];

				/*float[] gData = new float[3]; // accelerometer
				float[] mData = new float[3]; // magnetometer
				float[] rMat2 = new float[9];
				float[] iMat = new float[9];
				float[] orientation2 = new float[3];
				*/
				//text.append(String.format("Bearing to MW: %.3f", curBearingToMW)).append("\n");



				if (lastAccelerometer != null && lastCompass != null) {
					boolean gotRotation = SensorManager.getRotationMatrix(rotation, identity, lastAccelerometer, lastCompass);
					if (gotRotation) {
						//paint comppass o canvas
						canvas.save();
						canvas.rotate(lastCompass[0],Global.IcoTam,Global.IcoTam);//lastcomass[0] return azimut in degress
						mImageCompass.draw(canvas);
						canvas.restore();

						int distance=0;
						String distanceString="";
						for (int i=0;i<placesArrayList.size();i++) {
							pdiLocation.setLatitude(placesArrayList.get(i).getLatitud());
							pdiLocation.setLongitude(placesArrayList.get(i).getLongitud());
							pdiLocation.setAltitude(placesArrayList.get(i).getElevation());
							distance=(int)placesArrayList.get(i).getDistance();
							distanceString= String.valueOf(distance);
							curBearingToMW = lastLocation.bearingTo(pdiLocation);

							float cameraRotation[] = new float[9];
							// remap such that the camera is pointing straight down the Y axis
							SensorManager.remapCoordinateSystem(rotation, SensorManager.AXIS_X, SensorManager.AXIS_Z, cameraRotation);

							// orientation vector
							float orientation[] = new float[3];
							SensorManager.getOrientation(cameraRotation, orientation);
							//text.append(String.format("Orientation (%.3f, %.3f, %.3f)",	Math.toDegrees(orientation[0]), Math.toDegrees(orientation[1]), Math.toDegrees(orientation[2]))).append("\n");


							canvas.save();

							// use roll for screen rotation
							canvas.rotate((float) (0.0f - Math.toDegrees(orientation[2])));
							// Translate, but normalize for the FOV of the camera -- basically, pixels per degree, times degrees == pixels
							float dx = (float) ((getWidth() / horizontalFOV) * (Math.toDegrees(orientation[0]) - curBearingToMW));
							float dy = (float) ((getHeight() / verticalFOV) * Math.toDegrees(orientation[1]));
							// wait to translate the dx so the horizon doesn't get pushed off
											canvas.translate(0.0f, 0.0f-dy);
							//canvas.translate(0.0f - dx, 0.0f - dy);
							// make our line big enough to draw regardless of rotation and translation
							//canvas.drawLine(0f - canvas.getHeight(), canvas.getHeight()/2, canvas.getWidth()+canvas.getHeight(), canvas.getHeight()/2, targetPaint);
							// now translate the dx
											canvas.translate(0.0f-dx, 0.0f);
							// draw our point -- we've rotated and translated this to the right spot already
							placesArrayList.get(i).setPosX((int) Math.abs(dx));
							placesArrayList.get(i).setPosY((int) Math.abs(dy));

							if (((Global.radiusCF == 1)&&(distance<Global.radiusRadarClose))||((Global.radiusCF == 2)&&(distance<Global.radiusRadarFar))) //If point distance  is less than radius
							{
								if (pdiLocation.getAltitude()>Global.minElevation) //print PDI only if elevation>elevation in parameters
								{
									if (i!=RedPdiPos)
									{
										targetPaint.setColor(Color.GREEN);
									}
									else {
										targetPaint.setColor(Color.RED);
									}
									canvas.drawCircle(canvas.getWidth() / 2, canvas.getHeight() / 2, 25.0f, targetPaint);
									canvas.save();
									PDItext = new TextPaint(Paint.ANTI_ALIAS_FLAG);
									PDItext.setColor(Color.WHITE);
									PDItext.setTextAlign(Align.LEFT);
									PDItext.setTextSize(textSize);
									canvas.rotate(-50, canvas.getWidth() / 2, canvas.getHeight() / 2);
									canvas.drawText(placesArrayList.get(i).getPlaceName() + " " + (int) placesArrayList.get(i).getElevation() + "m", (canvas.getWidth() / 2) + 20, (canvas.getHeight() / 2) - 20, PDItext);

									canvas.save();
									canvas.rotate(130, canvas.getWidth() / 2, canvas.getHeight() / 2);
									canvas.drawText(distanceString + " m", (canvas.getWidth() / 2) +50, (canvas.getHeight() / 2) , PDItext);
									canvas.restore();

									canvas.restore();
								}
							}
							canvas.restore();

                            //SystemClock.sleep(delayView);
						}
					}
				}
			}
			else {
				//if arraylist of point =0          write     buscando....
				canvas.save();
				PDItext = new TextPaint(Paint.ANTI_ALIAS_FLAG);
				PDItext.setColor(Color.WHITE);
				PDItext.setTextAlign(Align.LEFT);
				PDItext.setTextSize(textSize);
				canvas.drawText("Buscando puntos de interes...", canvas.getWidth() / 4, canvas.getHeight() / 2, PDItext);
				canvas.restore();
			}

		}
		else {
			//if there is no location yet, write     buscando....
			canvas.save();
			PDItext = new TextPaint(Paint.ANTI_ALIAS_FLAG);
			PDItext.setColor(Color.WHITE);
			PDItext.setTextAlign(Align.LEFT);
			PDItext.setTextSize(textSize);
			canvas.drawText("GPS...", canvas.getWidth() / 4, canvas.getHeight() / 2, PDItext);
			canvas.restore();
		}

		//info sensores for debbug
		/*
		canvas.save();
		canvas.translate(15.0f, 15.0f);
		StaticLayout textBox = new StaticLayout(text.toString(), contentPaint,480, Alignment.ALIGN_NORMAL, 1.0f, 0.0f, true);
		textBox.draw(canvas);
		canvas.restore();*/
	}

	public void onAccuracyChanged(Sensor arg0, int arg1) {
		//Log.d(DEBUG_TAG, "onAccuracyChanged");
	}


	public void onSensorChanged(SensorEvent event) {
		// Log.d(DEBUG_TAG, "onSensorChanged");

		StringBuilder msg = new StringBuilder(event.sensor.getName()).append(" ");
		for (float value : event.values) {
			//msg.append("[").append(String.format("%.3f", value)).append("]");
		}

		float sensitive=0;
		if (lastAccelerometer != null)
		{
		  sensitive =(Math.abs(event.values[0] - lastAccelerometer[0]) + Math.abs(event.values[1] - lastAccelerometer[1]) + Math.abs(event.values[2] - lastAccelerometer[2]));
		}
		switch (event.sensor.getType()) {
		case Sensor.TYPE_ACCELEROMETER:
			if (lastAccelerometer==null)
			{
				lastAccelerometer = event.values.clone();
			}
			else
			{
				if (sensitive>0.5){
					lastAccelerometer = event.values.clone();}
			}
			accelData = msg.toString();
			break;
		case Sensor.TYPE_GYROSCOPE:
			gyroData = msg.toString();
			break;
		case Sensor.TYPE_MAGNETIC_FIELD:
			lastCompass = event.values.clone();
			compassData = msg.toString();
			break;
		case Sensor.TYPE_ORIENTATION:
//			Azimuth= (int) ((event.values[0]+360)%360);
			break;
		}

		this.invalidate();
	}

	public void onLocationChanged(Location location) {
		// store it off for use when we need it
		lastLocation = location;
	}

	public void onProviderDisabled(String provider) {
		// ...
	}

	public void onProviderEnabled(String provider) {
		// ...
	}

	public void onStatusChanged(String provider, int status, Bundle extras) {
		// ...
	}

	// this is not an override
	public void onPause() {
		locationManager.removeUpdates(this);
		sensors.unregisterListener(this);
	}

	// this is not an override
	public void onResume() {
		startSensors();
		startGPS();
	}
}
//fin Version 0.25