package com.crijaen.witpeak;

import android.location.Geocoder;
import android.location.Location;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import com.crijaen.witpeak.Objects.Adapter;
import com.crijaen.witpeak.Objects.Mark;
import com.crijaen.witpeak.Objects.FirebaseReferences;

import java.util.ArrayList;
import java.util.List;


public class PdiInfo extends AppCompatActivity {
    Button buttonMark;
    TextView texto;
    RecyclerView rv;
    List<Mark> marks;
    Adapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pdi_info);


        texto=findViewById(R.id.textView);
        rv=findViewById(R.id.recycler);
        rv.setLayoutManager(new LinearLayoutManager(this));
        marks=new ArrayList<>();

        ((AppCompatActivity)this).getSupportActionBar().setTitle(R.string.AditionalInfo);

        final FirebaseDatabase database = FirebaseDatabase.getInstance();
        adapter=new Adapter(marks);
        rv.setAdapter(adapter);

        database.getReference().getRoot().child(FirebaseReferences.PDI_REFERENCE).child(FirebaseReferences.MARK_REFERENCE).addValueEventListener((new ValueEventListener() {
            @Override
            public void onDataChange(@NonNull DataSnapshot dataSnapshot) {
                marks.removeAll(marks);
                for (DataSnapshot snapshot:dataSnapshot.getChildren()){
                    Mark mark = snapshot.getValue(Mark.class);

                    Location locationA = new Location("punto A");
                    locationA.setLatitude(mark.getLatitude());
                    locationA.setLongitude(mark.getLongitude());

                    Location locationB = new Location("punto B");
                    locationB.setLatitude(Global.latInfo);
                    locationB.setLongitude(Global.lonInfo);

                    float distance = locationA.distanceTo(locationB);
                    if (distance<Global.RadiusInfo)//if distance<50 meters...then show in infoView
                    {
                        marks.add(mark);
                    }
                    else
                    {
                        //open activity for new point info
                    }
                }
                adapter.notifyDataSetChanged();
            }

            @Override
            public void onCancelled(@NonNull DatabaseError databaseError) {

            }
        }));

      /*  final DatabaseReference myRefDB = database.getReference(FirebaseReferences.PDI_REFERENCE);
        buttonMark.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //loc.setLongitude((double) 28.6);loc.setLatitude((double) 13.4);
                Mark mark = new Mark("prueba",10,23,34,"hola hola");
                myRefDB.child(FirebaseReferences.MARK_REFERENCE).push().setValue(mark);
            }


            //Add a point
            //DatabaseReference myRefDB = database.getReference(FirebaseReferences.PDI_REFERENCE);
            //Mark mark2 = new Mark("prueba",Global.latInfo,Global.lonInfo,Global.eleInfo,"hola hola");
            //myRefDB.child(FirebaseReferences.MARK_REFERENCE).push().setValue(mark);


            //delete BD
            //DatabaseReference myRefDB = database.getReference(FirebaseReferences.PDI_REFERENCE);
            //Mark mark2 = new Mark("prueba",Global.latInfo,Global.lonInfo,Global.eleInfo,"hola hola");
            //myRefDB.child(FirebaseReferences.MARK_REFERENCE).removeValue();

        });*/





    }
}
