package com.crijaen.witpeak;

import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.os.Build;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Locale;
import java.util.concurrent.TimeUnit;


public class PreferencesActivity extends AppCompatActivity implements View.OnClickListener{
    private ImageButton sbutton;
    public Spinner SpinnerLan,SpinnerCou;
    public EditText editRC,editRF,editMinElevation;
    private int valorIntME = 100;
    public SeekBar seekBar;

    @RequiresApi(api = Build.VERSION_CODES.O)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_preferences);

        SharedPreferences preferencias = getSharedPreferences("WitPeakPReferences",MODE_PRIVATE);


        ((AppCompatActivity)this).getSupportActionBar().setTitle(R.string.Preferences);


        String language = preferencias.getString("language", "");
        String country = preferencias.getString("country", "");
        if ((language == "")&&(country == ""))
        {
            //need restart application in order to set language and region on preferences
        }   else{
            setAppLocale(language,country);
        }


        //*********************************************************************************
        //*******************Recovery Language/Country from preferences and show them into spinners
        //*********************************************************************************
        SpinnerLan = (Spinner) findViewById(R.id.spinnerLanguage);
        SpinnerCou = (Spinner) findViewById(R.id.spinnerCountry);
        ArrayList<String> languageList = new ArrayList<String>();
        ArrayList<String> CountryList = new ArrayList<String>();
        languageList.add("es");
        languageList.add("en");
        CountryList.add("ES");
        CountryList.add("EN");
        ArrayAdapter adpLan=new ArrayAdapter(PreferencesActivity.this,android.R.layout.simple_spinner_dropdown_item,languageList);
        ArrayAdapter adpCou=new ArrayAdapter(PreferencesActivity.this,android.R.layout.simple_spinner_dropdown_item,CountryList);
        SpinnerLan.setAdapter(adpLan);
        SpinnerCou.setAdapter(adpCou);
        //*********************************************************************************
        //*********************** set language/region on this activity
        //*********************************************************************************
        if ((language == "")&&(country == ""))
        {            //need restart application in order to set language and region on preferences
        }else        {
            if (language=="es") SpinnerLan.setSelection(0);
            if (country=="ES") SpinnerCou.setSelection(0);
            if (language=="en") SpinnerLan.setSelection(1);
            if (country=="EN") SpinnerCou.setSelection(1);

        }





        //*********************************************************************************
        //********************recovery from preferences and show radius CLOSE into textview
        //*********************************************************************************
        editRC = (EditText) findViewById(R.id.editradiusRadarClose);
        int valorInt;
        valorInt= (int) preferencias.getInt("radiusRadarClose",-1);
        if (valorInt==-1) {//if not exists...need to restart application in order to re-save initial preferences
            editRC.setFocusable(false);        }
        else
        {   editRC.setText(String.valueOf(valorInt));   }


        //*********************************************************************************
        //********************recovery from preferences and show radius FAR into textview
        //*********************************************************************************
        editRF = (EditText) findViewById(R.id.editradiusRadarFar);
        valorInt= (int) preferencias.getInt("radiusRadarFar",-1);
        if (valorInt==-1) {//if not exists...need to restart application in order to re-save initial preferences
            editRF.setFocusable(false);        }
        else
        {   editRF.setText(String.valueOf(valorInt));   }


        //*********************************************************************************
        //********************recovery from preferences and show minElevation into textview
        //*********************************************************************************
        editMinElevation = (EditText) findViewById(R.id.editminElevation);
        valorIntME= (int) preferencias.getInt("minElevation",-1);
        if (valorIntME==-1) {//if not exists...need to restart application in order to re-save initial preferences
            editMinElevation.setFocusable(false);        }
        else
        {   editMinElevation.setText(String.valueOf(valorIntME));   }


        //*********************************************************************************
        //******************** recovery from AccelSensibility
        //*********************************************************************************
        SeekBar seekBar = (SeekBar) findViewById(R.id.seekBar);
        seekBar.setMin(0);
        seekBar.setMax(9);
        //seekBar.setProgress(5);
        float valorAccel= (float) preferencias.getFloat("AccelSensibility",(float) -1);
        if (valorAccel ==-1) {//if not exists...need to restart application in order to re-save initial preferences
            editRF.setFocusable(false);        }
        else
        {   seekBar.setProgress((int) (valorAccel*10));}

        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {//on change listener--> change global parameter
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                    Global.AccelSensibility=(float)(progress+1)/10;
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });


        //configure save button
        sbutton = findViewById(R.id.ButtonSave);
        sbutton.setOnClickListener(this);
        //sbutton.setEnabled(false);
    }

    //*********************************************
    //******************************* Change Locale
    //*********************************************
    public void setAppLocale(String lan, String reg)
    {
        Locale localizacion = new Locale(lan, reg);
        Locale.setDefault(localizacion);
        Configuration config = new Configuration();
        config.locale = localizacion;
        getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());
    }


    @Override
    public void onClick(View v) {
        int radioClose;
        int radioFar;
        int minElevation;
        String lan,cou;

        SharedPreferences preferencias = getSharedPreferences("WitPeakPReferences",MODE_PRIVATE);
        switch (v.getId()){
            case R.id.ButtonSave:
                radioClose = Integer.parseInt(editRC.getText().toString());
                radioFar = Integer.parseInt(editRF.getText().toString());
                Global.needNewPoints=true;
                minElevation = Integer.parseInt(editMinElevation.getText().toString());
                if (minElevation != Global.minElevation) {Global.minElevation=minElevation;};//if minimun elevation change, need to change elevation on instance overlayview
                lan = SpinnerLan.getSelectedItem().toString();
                cou = SpinnerCou.getSelectedItem().toString();
                SharedPreferences.Editor editor = preferencias.edit();
                editor.putInt("radiusRadarClose", radioClose);
                editor.putInt("radiusRadarFar", radioFar);
                editor.putInt("minElevation", minElevation);
                editor.putString("language", lan);
                editor.putString("country", cou);
                editor.putFloat("AccelSensibility", Global.AccelSensibility);
                editor.commit();
                setAppLocale(lan,cou);

                Toast.makeText(getApplicationContext(),getResources().getString(R.string.SavingConfig),Toast.LENGTH_SHORT).show();
                finish();
                try {
                    TimeUnit.MICROSECONDS.sleep(250);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }

        }
    }
}
